diff --git a/libpurple/contact.c b/libpurple/contact.c
--- a/libpurple/contact.c
+++ b/libpurple/contact.c
@@ -21,24 +21,24 @@
  */
 
 #include "contact.h"
+
+#include "buddylist.h"
 #include "prefs.h"
 #include "purpleconversationmanager.h"
 #include "purpleprivate.h"
+#include "signals.h"
 #include "util.h"
 
 typedef struct _PurpleMetaContactPrivate    PurpleMetaContactPrivate;
 
 struct _PurpleMetaContactPrivate {
 	char *alias;                  /* The user-set alias of the contact  */
-	PurpleBuddy *priority_buddy;  /* The "top" buddy for this contact   */
-	gboolean priority_valid;      /* Is priority valid?                 */
 };
 
 enum
 {
 	PROP_0,
 	PROP_ALIAS,
-	PROP_PRIORITY_BUDDY,
 	N_PROPERTIES,
 };
 
@@ -53,53 +53,6 @@
 /******************************************************************************
  * API
  *****************************************************************************/
-static void
-purple_meta_contact_compute_priority_buddy(PurpleMetaContact *contact) {
-	PurpleBlistNode *bnode;
-	PurpleBuddy *new_priority = NULL;
-	PurpleMetaContactPrivate *priv =
-			purple_meta_contact_get_instance_private(contact);
-
-	priv->priority_buddy = NULL;
-	for (bnode = PURPLE_BLIST_NODE(contact)->child;
-			bnode != NULL;
-			bnode = bnode->next)
-	{
-		PurpleBuddy *buddy;
-
-		if (!PURPLE_IS_BUDDY(bnode))
-			continue;
-
-		buddy = PURPLE_BUDDY(bnode);
-		if (new_priority == NULL)
-		{
-			new_priority = buddy;
-			continue;
-		}
-
-		if (purple_account_is_connected(purple_buddy_get_account(buddy)))
-		{
-			int cmp = 1;
-			if (purple_account_is_connected(purple_buddy_get_account(new_priority)))
-				cmp = purple_presence_compare(
-						purple_buddy_get_presence(new_priority),
-						purple_buddy_get_presence(buddy));
-
-			if (cmp > 0 || (cmp == 0 &&
-			                purple_prefs_get_bool("/purple/contact/last_match")))
-			{
-				new_priority = buddy;
-			}
-		}
-	}
-
-	priv->priority_buddy = new_priority;
-	priv->priority_valid = TRUE;
-
-	g_object_notify_by_pspec(G_OBJECT(contact),
-			properties[PROP_PRIORITY_BUDDY]);
-}
-
 void
 purple_meta_contact_set_alias(PurpleMetaContact *contact, const char *alias)
 {
@@ -149,50 +102,7 @@
 	if (priv->alias)
 		return priv->alias;
 
-	return purple_buddy_get_alias(purple_meta_contact_get_priority_buddy(contact));
-}
-
-gboolean purple_meta_contact_on_account(PurpleMetaContact *c, PurpleAccount *account)
-{
-	PurpleBlistNode *bnode, *cnode = (PurpleBlistNode *) c;
-
-	g_return_val_if_fail(PURPLE_IS_META_CONTACT(c), FALSE);
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), FALSE);
-
-	for (bnode = cnode->child; bnode; bnode = bnode->next) {
-		PurpleBuddy *buddy;
-
-		if (! PURPLE_IS_BUDDY(bnode))
-			continue;
-
-		buddy = (PurpleBuddy *)bnode;
-		if (purple_buddy_get_account(buddy) == account)
-			return TRUE;
-	}
-	return FALSE;
-}
-
-void purple_meta_contact_invalidate_priority_buddy(PurpleMetaContact *contact)
-{
-	PurpleMetaContactPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_META_CONTACT(contact));
-
-	priv = purple_meta_contact_get_instance_private(contact);
-	priv->priority_valid = FALSE;
-}
-
-PurpleBuddy *purple_meta_contact_get_priority_buddy(PurpleMetaContact *contact)
-{
-	PurpleMetaContactPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_META_CONTACT(contact), NULL);
-
-	priv = purple_meta_contact_get_instance_private(contact);
-	if (!priv->priority_valid)
-		purple_meta_contact_compute_priority_buddy(contact);
-
-	return priv->priority_buddy;
+	return NULL;
 }
 
 /**************************************************************************
@@ -228,9 +138,6 @@
 		case PROP_ALIAS:
 			g_value_set_string(value, priv->alias);
 			break;
-		case PROP_PRIORITY_BUDDY:
-			g_value_set_object(value, purple_meta_contact_get_priority_buddy(contact));
-			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
 			break;
@@ -283,21 +190,6 @@
 		G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS
 	);
 
-	/**
-	 * PurpleMetaContact:priority-buddy:
-	 *
-	 * The priority buddy of the contact.
-	 *
-	 * Since: 3.0
-	 */
-	properties[PROP_PRIORITY_BUDDY] = g_param_spec_object(
-		"priority-buddy",
-		"Priority buddy",
-		"The priority buddy of the contact.",
-		PURPLE_TYPE_BUDDY,
-		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS
-	);
-
 	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
 }
 
diff --git a/libpurple/conversations.c b/libpurple/conversations.c
--- a/libpurple/conversations.c
+++ b/libpurple/conversations.c
@@ -25,6 +25,7 @@
 #include "prefs.h"
 #include "purpleprivate.h"
 #include "purpleconversationmanager.h"
+#include "signals.h"
 
 void *
 purple_conversations_get_handle(void)
diff --git a/libpurple/core.c b/libpurple/core.c
--- a/libpurple/core.c
+++ b/libpurple/core.c
@@ -26,6 +26,7 @@
 #define G_SETTINGS_ENABLE_BACKEND
 #include <gio/gsettingsbackend.h>
 
+#include "buddylist.h"
 #include "cmds.h"
 #include "connection.h"
 #include "conversations.h"
@@ -147,10 +148,6 @@
 	 */
 	purple_plugins_init();
 
-	/* Accounts buddy icons and connection signals, so initialize these before
-	 * accounts.
-	 */
-	purple_buddy_icons_init();
 	purple_connections_init();
 
 	purple_account_manager_startup();
@@ -235,7 +232,6 @@
 	purple_blist_uninit();
 	purple_notify_uninit();
 	purple_connections_uninit();
-	purple_buddy_icons_uninit();
 	purple_presence_manager_shutdown();
 	purple_accounts_uninit();
 	purple_proxy_uninit();
diff --git a/libpurple/group.c b/libpurple/group.c
--- a/libpurple/group.c
+++ b/libpurple/group.c
@@ -22,9 +22,12 @@
 
 #include "group.h"
 
+#include "buddylist.h"
+#include "contact.h"
 #include "debug.h"
 #include "purpleprivate.h"
 #include "purpleprotocolserver.h"
+#include "util.h"
 
 typedef struct _PurpleGroupPrivate      PurpleGroupPrivate;
 
@@ -56,34 +59,15 @@
 /******************************************************************************
  * Group API
  *****************************************************************************/
-GSList *purple_group_get_accounts(PurpleGroup *group) {
-	GSList *l = NULL;
-	PurpleBlistNode *gnode, *cnode, *bnode;
-
-	gnode = (PurpleBlistNode *)group;
-
-	for (cnode = gnode->child;  cnode; cnode = cnode->next) {
-		if (PURPLE_IS_META_CONTACT(cnode)) {
-			for (bnode = cnode->child; bnode; bnode = bnode->next) {
-				if (PURPLE_IS_BUDDY(bnode)) {
-					if (!g_slist_find(l, purple_buddy_get_account(PURPLE_BUDDY(bnode))))
-						l = g_slist_append(l, purple_buddy_get_account(PURPLE_BUDDY(bnode)));
-				}
-			}
-		}
-	}
-
-	return l;
+GSList *
+purple_group_get_accounts(G_GNUC_UNUSED PurpleGroup *group) {
+	return NULL;
 }
 
-gboolean purple_group_on_account(PurpleGroup *g, PurpleAccount *account) {
-	PurpleBlistNode *cnode;
-	for (cnode = ((PurpleBlistNode *)g)->child; cnode; cnode = cnode->next) {
-		if (PURPLE_IS_META_CONTACT(cnode)) {
-			if(purple_meta_contact_on_account((PurpleMetaContact *) cnode, account))
-				return TRUE;
-		}
-	}
+gboolean
+purple_group_on_account(G_GNUC_UNUSED PurpleGroup *g,
+                        G_GNUC_UNUSED PurpleAccount *account)
+{
 	return FALSE;
 }
 
@@ -129,13 +113,7 @@
 		{
 			next = child->next;
 			if (PURPLE_IS_META_CONTACT(child)) {
-				PurpleBlistNode *bnode;
 				purple_blist_add_contact((PurpleMetaContact *)child, dest, prev);
-				for (bnode = child->child; bnode != NULL; bnode = bnode->next) {
-					purple_blist_add_buddy((PurpleBuddy *)bnode, (PurpleMetaContact *)child,
-							NULL, bnode->prev);
-					moved_buddies = g_list_append(moved_buddies, bnode);
-				}
 				prev = child;
 			} else {
 				purple_debug_error("blistnodetypes", "Unknown child type in group %s", priv->name);
@@ -183,7 +161,7 @@
 			PurpleAccount *account = accts->data;
 			PurpleConnection *gc = NULL;
 			PurpleProtocol *protocol = NULL;
-			GList *l = NULL, *buddies = NULL;
+			GList *buddies = NULL;
 
 			gc = purple_account_get_connection(account);
 
@@ -193,13 +171,6 @@
 			if(!protocol)
 				continue;
 
-			for(l = moved_buddies; l; l = l->next) {
-				PurpleBuddy *buddy = PURPLE_BUDDY(l->data);
-
-				if(buddy && purple_buddy_get_account(buddy) == account)
-					buddies = g_list_append(buddies, (PurpleBlistNode *)buddy);
-			}
-
 			if(PURPLE_PROTOCOL_IMPLEMENTS(protocol, SERVER, rename_group)) {
 				purple_protocol_server_rename_group(PURPLE_PROTOCOL_SERVER(protocol),
 				                                    gc, old_name, source,
@@ -213,9 +184,7 @@
 					groups = g_list_prepend(groups, node->parent->parent);
 				}
 
-				purple_account_remove_buddies(account, buddies, groups);
 				g_list_free(groups);
-				purple_account_add_buddies(account, buddies, NULL);
 			}
 
 			g_list_free(buddies);
@@ -346,8 +315,6 @@
 		name = PURPLE_BLIST_DEFAULT_GROUP_NAME;
 	if (g_strcmp0(name, "Buddies") == 0)
 		name = PURPLE_BLIST_DEFAULT_GROUP_NAME;
-	if (g_strcmp0(name, _purple_blist_get_localized_default_group_name()) == 0)
-		name = PURPLE_BLIST_DEFAULT_GROUP_NAME;
 
 	group = purple_blist_find_group(name);
 	if (group != NULL)
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -2,9 +2,7 @@
 	'accounts.c',
 	'action.c',
 	'blistnode.c',
-	'buddy.c',
 	'buddylist.c',
-	'buddyicon.c',
 	'circularbuffer.c',
 	'cmds.c',
 	'connection.c',
@@ -111,9 +109,7 @@
 	'accounts.h',
 	'action.h',
 	'blistnode.h',
-	'buddy.h',
 	'buddylist.h',
-	'buddyicon.h',
 	'circularbuffer.h',
 	'cmds.h',
 	'connection.h',
@@ -266,7 +262,6 @@
 ]
 
 purple_enumheaders = [
-	'buddyicon.h',
 	'connection.h',
 	'debug.h',
 	'notify.h',
diff --git a/libpurple/purpleaccount.h b/libpurple/purpleaccount.h
--- a/libpurple/purpleaccount.h
+++ b/libpurple/purpleaccount.h
@@ -506,62 +506,6 @@
 gboolean purple_account_get_bool(PurpleAccount *account, const char *name, gboolean default_value);
 
 /**
- * purple_account_add_buddy:
- * @account: The account.
- * @buddy: The buddy to add.
- * @message: The invite message.  This may be ignored by a protocol.
- *
- * Adds a buddy to the server-side buddy list for the specified account.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_add_buddy(PurpleAccount *account, PurpleBuddy *buddy, const char *message);
-
-/**
- * purple_account_add_buddies:
- * @account: The account.
- * @buddies: (element-type PurpleBuddy): The list of PurpleBlistNodes representing the buddies to add.
- * @message: The invite message.  This may be ignored by a protocol.
- *
- * Adds a list of buddies to the server-side buddy list.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_add_buddies(PurpleAccount *account, GList *buddies, const char *message);
-
-/**
- * purple_account_remove_buddy:
- * @account: The account.
- * @buddy: The buddy to remove.
- * @group: The group to remove the buddy from.
- *
- * Removes a buddy from the server-side buddy list.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_remove_buddy(PurpleAccount *account, PurpleBuddy *buddy, PurpleGroup *group);
-
-/**
- * purple_account_remove_buddies:
- * @account: The account.
- * @buddies: (element-type PurpleBuddy): The list of buddies to remove.
- * @groups: (element-type PurpleGroup): The list of groups to remove buddies from.  Each node of this
- *               list should match the corresponding node of buddies.
- *
- * Removes a list of buddies from the server-side buddy list.
- *
- * Note: The lists buddies and groups are parallel lists.  Be sure that node n of
- *       groups matches node n of buddies.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_remove_buddies(PurpleAccount *account, GList *buddies, GList *groups);
-
-/**
  * purple_account_remove_group:
  * @account: The account.
  * @group: The group to remove.
@@ -587,20 +531,6 @@
 void purple_account_change_password(PurpleAccount *account, const char *orig_pw, const char *new_pw);
 
 /**
- * purple_account_supports_offline_message:
- * @account: The account
- * @buddy: The buddy
- *
- * Whether the account supports sending offline messages to buddy.
- *
- * Returns: %TRUE if offline messages are supported, otherwise %FALSE.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-gboolean purple_account_supports_offline_message(PurpleAccount *account, PurpleBuddy *buddy);
-
-/**
  * purple_account_get_error:
  * @account: The account whose error should be retrieved.
  *
diff --git a/libpurple/purpleaccount.c b/libpurple/purpleaccount.c
--- a/libpurple/purpleaccount.c
+++ b/libpurple/purpleaccount.c
@@ -391,24 +391,6 @@
 }
 
 static void
-purple_account_changed_cb(GObject *obj, GParamSpec *pspec,
-                          G_GNUC_UNUSED gpointer data)
-{
-	const char *name = NULL;
-
-	purple_accounts_schedule_save();
-
-	name = g_param_spec_get_name(pspec);
-	if(purple_strequal(name, "username")) {
-		/* if the username changes, we should re-write the buddy list to disk
-		 * with the new name.
-		  */
-		purple_blist_save_account(purple_blist_get_default(),
-		                          PURPLE_ACCOUNT(obj));
-	}
-}
-
-static void
 purple_account_connection_state_cb(GObject *obj,
                                    G_GNUC_UNUSED GParamSpec *pspec,
                                    gpointer data)
@@ -776,10 +758,6 @@
 	}
 
 	account->presence = purple_presence_new();
-
-	/* Connect to our own notify signal so we can update accounts.xml. */
-	g_signal_connect(object, "notify",
-	                 G_CALLBACK(purple_account_changed_cb), NULL);
 }
 
 static void
@@ -1635,87 +1613,6 @@
 }
 
 void
-purple_account_add_buddy(PurpleAccount *account, PurpleBuddy *buddy,
-                         const char *message)
-{
-	PurpleProtocol *protocol = NULL;
-	PurpleConnection *gc;
-
-	g_return_if_fail(PURPLE_IS_ACCOUNT(account));
-	g_return_if_fail(PURPLE_IS_BUDDY(buddy));
-
-	gc = purple_account_get_connection(account);
-	if(gc != NULL) {
-		protocol = purple_connection_get_protocol(gc);
-	}
-
-	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
-		PurpleGroup *group = purple_buddy_get_group(buddy);
-
-		purple_protocol_server_add_buddy(PURPLE_PROTOCOL_SERVER(protocol), gc,
-		                                 buddy, group, message);
-	}
-}
-
-void
-purple_account_add_buddies(PurpleAccount *account, GList *buddies,
-                           const char *message)
-{
-	PurpleProtocol *protocol = NULL;
-	PurpleConnection *gc = purple_account_get_connection(account);
-
-	if(gc != NULL) {
-		protocol = purple_connection_get_protocol(gc);
-	}
-
-	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
-		PurpleProtocolServer *server = PURPLE_PROTOCOL_SERVER(protocol);
-
-		for(GList *b = buddies; b != NULL; b = b->next) {
-			PurpleBuddy *buddy = b->data;
-
-			purple_protocol_server_add_buddy(server, gc, buddy,
-			                                 purple_buddy_get_group(buddy),
-			                                 message);
-		}
-	}
-}
-
-void
-purple_account_remove_buddy(PurpleAccount *account, PurpleBuddy *buddy,
-                            PurpleGroup *group)
-{
-	PurpleProtocol *protocol = NULL;
-	PurpleConnection *gc = purple_account_get_connection(account);
-
-	if(gc != NULL) {
-		protocol = purple_connection_get_protocol(gc);
-	}
-
-	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
-		purple_protocol_server_remove_buddy(PURPLE_PROTOCOL_SERVER(protocol),
-		                                    gc, buddy, group);
-	}
-}
-
-void
-purple_account_remove_buddies(PurpleAccount *account, GList *buddies,
-                              GList *groups)
-{
-	PurpleProtocol *protocol = NULL;
-	PurpleConnection *gc = purple_account_get_connection(account);
-
-	if(gc != NULL) {
-		protocol = purple_connection_get_protocol(gc);
-	}
-
-	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
-		purple_protocol_server_remove_buddies(PURPLE_PROTOCOL_SERVER(protocol),
-		                                      gc, buddies, groups);
-	}
-}
-
-void
 purple_account_remove_group(PurpleAccount *account, PurpleGroup *group) {
 	PurpleProtocol *protocol = NULL;
 	PurpleConnection *gc = purple_account_get_connection(account);
@@ -1755,30 +1652,6 @@
 	}
 }
 
-gboolean
-purple_account_supports_offline_message(PurpleAccount *account,
-                                        PurpleBuddy *buddy)
-{
-	PurpleConnection *gc;
-	PurpleProtocol *protocol = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), FALSE);
-	g_return_val_if_fail(PURPLE_IS_BUDDY(buddy), FALSE);
-
-	gc = purple_account_get_connection(account);
-	if(gc == NULL) {
-		return FALSE;
-	}
-
-	protocol = purple_connection_get_protocol(gc);
-	if(!protocol) {
-		return FALSE;
-	}
-
-	return purple_protocol_client_offline_message(PURPLE_PROTOCOL_CLIENT(protocol),
-	                                              buddy);
-}
-
 const PurpleConnectionErrorInfo *
 purple_account_get_error(PurpleAccount *account) {
 	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
diff --git a/libpurple/purpleaccountmanager.c b/libpurple/purpleaccountmanager.c
--- a/libpurple/purpleaccountmanager.c
+++ b/libpurple/purpleaccountmanager.c
@@ -26,6 +26,7 @@
 #include "accounts.h"
 #include "core.h"
 #include "purpleaccount.h"
+#include "util.h"
 
 enum {
 	PROP_0,
diff --git a/libpurple/purpleauthorizationrequestnotification.c b/libpurple/purpleauthorizationrequestnotification.c
--- a/libpurple/purpleauthorizationrequestnotification.c
+++ b/libpurple/purpleauthorizationrequestnotification.c
@@ -24,6 +24,8 @@
 
 #include "purpleauthorizationrequestnotification.h"
 
+#include "util.h"
+
 enum {
 	PROP_0,
 	PROP_AUTHORIZATION_REQUEST,
diff --git a/libpurple/purpleconversation.h b/libpurple/purpleconversation.h
--- a/libpurple/purpleconversation.h
+++ b/libpurple/purpleconversation.h
@@ -155,7 +155,6 @@
 	gpointer reserved[4];
 };
 
-#include "buddyicon.h"
 #include "purpleaccount.h"
 
 G_BEGIN_DECLS
diff --git a/libpurple/purpleconversation.c b/libpurple/purpleconversation.c
--- a/libpurple/purpleconversation.c
+++ b/libpurple/purpleconversation.c
@@ -35,6 +35,8 @@
 #include "purpleprivate.h"
 #include "purpleprotocolconversation.h"
 #include "purpletags.h"
+#include "signals.h"
+#include "util.h"
 
 typedef struct {
 	char *id;
diff --git a/libpurple/purpleconversationmanager.c b/libpurple/purpleconversationmanager.c
--- a/libpurple/purpleconversationmanager.c
+++ b/libpurple/purpleconversationmanager.c
@@ -24,6 +24,7 @@
 
 #include "purplecontact.h"
 #include "purpleprivate.h"
+#include "util.h"
 
 enum {
 	SIG_REGISTERED,
diff --git a/libpurple/purplecredentialmanager.c b/libpurple/purplecredentialmanager.c
--- a/libpurple/purplecredentialmanager.c
+++ b/libpurple/purplecredentialmanager.c
@@ -30,6 +30,7 @@
 #include "prefs.h"
 #include "purplenoopcredentialprovider.h"
 #include "purpleprivate.h"
+#include "signals.h"
 #include "util.h"
 
 enum {
diff --git a/libpurple/purplenotification.c b/libpurple/purplenotification.c
--- a/libpurple/purplenotification.c
+++ b/libpurple/purplenotification.c
@@ -25,6 +25,7 @@
 #include "purplenotification.h"
 
 #include "purpleenums.h"
+#include "util.h"
 
 typedef struct {
 	char *id;
diff --git a/libpurple/purplepresence.c b/libpurple/purplepresence.c
--- a/libpurple/purplepresence.c
+++ b/libpurple/purplepresence.c
@@ -27,6 +27,7 @@
 #include "debug.h"
 #include "purpleenums.h"
 #include "purpleprivate.h"
+#include "util.h"
 
 typedef struct {
 	gboolean idle;
diff --git a/libpurple/purpleprivate.h b/libpurple/purpleprivate.h
--- a/libpurple/purpleprivate.h
+++ b/libpurple/purpleprivate.h
@@ -35,6 +35,7 @@
 #include "purplecredentialprovider.h"
 #include "purplehistoryadapter.h"
 #include "purpleversion.h"
+#include "xmlnode.h"
 
 G_BEGIN_DECLS
 
@@ -60,16 +61,6 @@
 G_GNUC_INTERNAL
 PurpleBlistNode *_purple_blist_get_last_child(PurpleBlistNode *node);
 
-/* This is for the accounts code to notify the buddy icon code that
- * it's done loading.  We may want to replace this with a signal. */
-G_GNUC_INTERNAL
-void _purple_buddy_icons_account_loaded_cb(void);
-
-/* This is for the buddy list to notify the buddy icon code that
- * it's done loading.  We may want to replace this with a signal. */
-G_GNUC_INTERNAL
-void _purple_buddy_icons_blist_loaded_cb(void);
-
 /**
  * _purple_connection_wants_to_die:
  * @gc:  The connection to check
diff --git a/libpurple/purpleprotocol.h b/libpurple/purpleprotocol.h
--- a/libpurple/purpleprotocol.h
+++ b/libpurple/purpleprotocol.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include <gio/gio.h>
+
 #include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL (purple_protocol_get_type())
@@ -46,7 +48,6 @@
 G_DECLARE_DERIVABLE_TYPE(PurpleProtocol, purple_protocol, PURPLE, PROTOCOL,
                          GObject)
 
-#include "buddyicon.h"
 #include "connection.h"
 #include "purpleaccount.h"
 #include "purplewhiteboardops.h"
@@ -117,7 +118,6 @@
  *                   procotol provides.
  * @get_account_options: Returns a list of all #PurpleAccountOption's for the
  *                       protocol.
- * @get_buddy_icon_spec: Returns a #PurpleBuddyIconSpec that should be used.
  * @get_whiteboard_ops: Return the #PurpleWhiteboardOps that should be used.
  * @login: Logs into the server.
  * @close: Close sconnection with the server.
@@ -139,7 +139,6 @@
 
 	GList *(*get_user_splits)(PurpleProtocol *protocol);
 	GList *(*get_account_options)(PurpleProtocol *protocol);
-	PurpleBuddyIconSpec *(*get_buddy_icon_spec)(PurpleProtocol *protocol);
 	PurpleWhiteboardOps *(*get_whiteboard_ops)(PurpleProtocol *protocol);
 
 	void (*can_connect_async)(PurpleProtocol *protocol, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
@@ -252,19 +251,6 @@
 GList *purple_protocol_get_account_options(PurpleProtocol *protocol);
 
 /**
- * purple_protocol_get_icon_spec:
- * @protocol: The #PurpleProtocol instance.
- *
- * Gets the icon spec of a protocol.
- *
- * Returns: (transfer full): The icon spec of the protocol.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-PurpleBuddyIconSpec *purple_protocol_get_icon_spec(PurpleProtocol *protocol);
-
-/**
  * purple_protocol_get_whiteboard_ops:
  * @protocol: The #PurpleProtocol instance.
  *
diff --git a/libpurple/purpleprotocol.c b/libpurple/purpleprotocol.c
--- a/libpurple/purpleprotocol.c
+++ b/libpurple/purpleprotocol.c
@@ -26,6 +26,7 @@
 #include "prefs.h"
 #include "purpleaccountmanager.h"
 #include "purpleenums.h"
+#include "signals.h"
 
 enum {
 	PROP_0,
@@ -491,20 +492,6 @@
 	return NULL;
 }
 
-PurpleBuddyIconSpec *
-purple_protocol_get_icon_spec(PurpleProtocol *protocol) {
-	PurpleProtocolClass *klass = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_PROTOCOL(protocol), NULL);
-
-	klass = PURPLE_PROTOCOL_GET_CLASS(protocol);
-	if(klass != NULL && klass->get_buddy_icon_spec != NULL) {
-		return klass->get_buddy_icon_spec(protocol);
-	}
-
-	return NULL;
-}
-
 PurpleWhiteboardOps *
 purple_protocol_get_whiteboard_ops(PurpleProtocol *protocol) {
 	PurpleProtocolClass *klass = NULL;
diff --git a/libpurple/purpleprotocolclient.h b/libpurple/purpleprotocolclient.h
--- a/libpurple/purpleprotocolclient.h
+++ b/libpurple/purpleprotocolclient.h
@@ -56,14 +56,10 @@
 	GTypeInterface parent;
 
 	/*< public >*/
-	void (*buddy_free)(PurpleProtocolClient *client, PurpleBuddy *buddy);
-
 	void (*convo_closed)(PurpleProtocolClient *client, PurpleConnection *connection, const gchar *who);
 
 	const gchar *(*normalize)(PurpleProtocolClient *client, PurpleAccount *account, const gchar *who);
 
-	gboolean (*offline_message)(PurpleProtocolClient *client, PurpleBuddy *buddy);
-
 	/*< private >*/
 	gpointer reserved[4];
 };
@@ -71,18 +67,6 @@
 G_BEGIN_DECLS
 
 /**
- * purple_protocol_client_buddy_free:
- * @client: The #PurpleProtocolClient instance.
- * @buddy: A #PurpleBuddy instance.
- *
- * Cleans up any protocol specific data for @buddy.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-void purple_protocol_client_buddy_free(PurpleProtocolClient *client, PurpleBuddy *buddy);
-
-/**
  * purple_protocol_client_convo_closed:
  * @client: The #PurpleProtocolClient instance.
  * @connection: A #PurpleConnection instance.
@@ -115,20 +99,6 @@
 PURPLE_DEPRECATED
 const gchar *purple_protocol_client_normalize(PurpleProtocolClient *client, PurpleAccount *account, const gchar *who);
 
-/**
- * purple_protocol_client_offline_message:
- * @client: The #PurpleProtocolClient instance.
- * @buddy: A #PurpleBuddy instance.
- *
- * Checks whether offline messages to @buddy are supported.
- *
- * Returns: %TRUE if @buddy supports offline messages, otherwise %FALSE.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-gboolean purple_protocol_client_offline_message(PurpleProtocolClient *client, PurpleBuddy *buddy);
-
 G_END_DECLS
 
 #endif /* PURPLE_PROTOCOL_CLIENT_H */
diff --git a/libpurple/purpleprotocolclient.c b/libpurple/purpleprotocolclient.c
--- a/libpurple/purpleprotocolclient.c
+++ b/libpurple/purpleprotocolclient.c
@@ -39,21 +39,6 @@
  * Public API
  *****************************************************************************/
 void
-purple_protocol_client_buddy_free(PurpleProtocolClient *client,
-                                  PurpleBuddy *buddy)
-{
-	PurpleProtocolClientInterface *iface = NULL;
-
-	g_return_if_fail(PURPLE_IS_PROTOCOL_CLIENT(client));
-	g_return_if_fail(PURPLE_IS_BUDDY(buddy));
-
-	iface = PURPLE_PROTOCOL_CLIENT_GET_IFACE(client);
-	if(iface != NULL && iface->buddy_free != NULL) {
-		iface->buddy_free(client, buddy);
-	}
-}
-
-void
 purple_protocol_client_convo_closed(PurpleProtocolClient *client,
                                     PurpleConnection *connection,
                                     const gchar *who)
@@ -86,20 +71,3 @@
 
 	return NULL;
 }
-
-gboolean
-purple_protocol_client_offline_message(PurpleProtocolClient *client,
-                                       PurpleBuddy *buddy)
-{
-	PurpleProtocolClientInterface *iface = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_PROTOCOL_CLIENT(client), FALSE);
-	g_return_val_if_fail(PURPLE_IS_BUDDY(buddy), FALSE);
-
-	iface = PURPLE_PROTOCOL_CLIENT_GET_IFACE(client);
-	if(iface != NULL && iface->offline_message != NULL) {
-		return iface->offline_message(client, buddy);
-	}
-
-	return FALSE;
-}
diff --git a/libpurple/purpleprotocolcontacts.c b/libpurple/purpleprotocolcontacts.c
--- a/libpurple/purpleprotocolcontacts.c
+++ b/libpurple/purpleprotocolcontacts.c
@@ -22,6 +22,8 @@
 
 #include "purpleprotocolcontacts.h"
 
+#include "util.h"
+
 /******************************************************************************
  * GInterface Implementation
  *****************************************************************************/
